﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	
	Private oAuthClientEmail As String
	Private oAuthClientPassword As String
	Private oAuthWebApiKey As String
	Private oAuthAuthorizationCode, oAuthAccessToken, oAuthLocalId, oAuthRefreshToken As String
	Private oAuthLoggedIn As Boolean = False

	Private sEventName As String
	Private oModule As Object
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(ClientEmail As String, ClientPassword As String, WebApiKey As String, EventName As String, Module As Object)
	oAuthClientEmail = ClientEmail
	oAuthClientPassword = ClientPassword
	oAuthWebApiKey = WebApiKey
	sEventName = EventName
	oModule = Module
End Sub

Public Sub GetAccessTokenSimple
	Dim Url As String = $"https://www.googleapis.com/identitytoolkit/v3/relyingparty/verifyPassword?key=${oAuthWebApiKey}"$
	Dim m As Map = CreateMap("email":oAuthClientEmail, "password":oAuthClientPassword, "returnSecureToken":True)
	Dim job As HttpJob
	job.Initialize("GetAccessTokenSimple", Me)
	job.PostString(Url, Parse2(m))
	job.GetRequest.SetContentType("application/json")
End Sub


Public Sub Write
	Dim Url As String = $"${Main.DBURL}users.json?access_token=${oAuthAccessToken}"$
	
	Dim m As Map = CreateMap("summary":"Hello one again", "description":1111111)
	Dim job As HttpJob
	job.Initialize("testInsert", Me)
	job.PostString(Url, Parse2(m))
	job.GetRequest.SetContentType("application/json")
End Sub



Private Sub JobDone (Job As HttpJob)
	If Job.Success Then
		Select Job.JobName			
			Case "testInsert"
				Log("inserted")

			Case "GetAccessTokenSimple"
				Dim m As Map = Parse(Job.GetString)
				oAuthAccessToken = m.GetDefault("idToken", "")
				If m.GetDefault("refreshToken", "") <> "" Then
					oAuthRefreshToken = m.GetDefault("refreshToken", "")
				End If	
				If oAuthAccessToken <> "" Then
					Log("Connection with Firebase Database Successful.")
					If oAuthRefreshToken <> "" Then File.WriteMap(File.DirApp, "token.ini", CreateMap("refreshToken":oAuthRefreshToken))
					Log($"oAuthRefreshToken = ${oAuthRefreshToken}"$)
					oAuthLoggedIn = True
					
					If sEventName <> "" And SubExists(oModule, sEventName & "_Connected") Then
						CallSubDelayed(oModule, sEventName & "_Connected")
					End If
					
				End If
				
		End Select
	Else
		Log(Job.ErrorMessage)
	End If
End Sub	


Private Sub Parse(s As String) As Map
	Dim Parser As JSONParser
	Parser.Initialize(s)
	Return Parser.NextObject
End Sub	
Private Sub Parse2(m As Map) As String
	Dim Parser As JSONGenerator
	Parser.Initialize(m)
	Return Parser.ToString
End Sub	

Private Sub asjo(o As JavaObject) As JavaObject
	Return o
End Sub	